# InstanceApi

All URIs are relative to *https://api.browshot.com/api/v1*

Method | HTTP request | Description
------------- | ------------- | -------------
[**instanceInfoGet**](InstanceApi.md#instanceInfoGet) | **GET** /instance/info | Get information about an instance
[**instanceListGet**](InstanceApi.md#instanceListGet) | **GET** /instance/list | Get all instances


<a name="instanceInfoGet"></a>
# **instanceInfoGet**
> Instance instanceInfoGet(id)

Get information about an instance

Get information about an instance.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.InstanceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure API key authorization: apiKeyQuery
ApiKeyAuth apiKeyQuery = (ApiKeyAuth) defaultClient.getAuthentication("apiKeyQuery");
apiKeyQuery.setApiKey("YOUR API KEY");
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//apiKeyQuery.setApiKeyPrefix("Token");

InstanceApi apiInstance = new InstanceApi();
Integer id = 56; // Integer | instance ID
try {
    Instance result = apiInstance.instanceInfoGet(id);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling InstanceApi#instanceInfoGet");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **Integer**| instance ID |

### Return type

[**Instance**](Instance.md)

### Authorization

[apiKeyQuery](../README.md#apiKeyQuery)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="instanceListGet"></a>
# **instanceListGet**
> InstanceList instanceListGet()

Get all instances

Get all instances.

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.InstanceApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();

// Configure API key authorization: apiKeyQuery
ApiKeyAuth apiKeyQuery = (ApiKeyAuth) defaultClient.getAuthentication("apiKeyQuery");
apiKeyQuery.setApiKey("YOUR API KEY");
// Uncomment the following line to set a prefix for the API key, e.g. "Token" (defaults to null)
//apiKeyQuery.setApiKeyPrefix("Token");

InstanceApi apiInstance = new InstanceApi();
try {
    InstanceList result = apiInstance.instanceListGet();
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling InstanceApi#instanceListGet");
    e.printStackTrace();
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**InstanceList**](InstanceList.md)

### Authorization

[apiKeyQuery](../README.md#apiKeyQuery)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

