/*
 * Browshot API
 * Take screenshots of any website in real time
 *
 * OpenAPI spec version: 1.16.0
 * Contact: support@browshot.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.api;

import io.swagger.client.ApiCallback;
import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import io.swagger.client.model.Batch;
import io.swagger.client.model.BatchError;
import java.io.File;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class BatchApi {
    private ApiClient apiClient;

    public BatchApi() {
        this(Configuration.getDefaultApiClient());
    }

    public BatchApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /* Build call for batchCeatePost */
    private com.squareup.okhttp.Call batchCeatePostCall(Integer instanceId, File file, String size, String name, Integer width, Integer height, Integer delay, Integer flashDelay, Integer screenWidth, Integer screenHeight, Integer priority, String referer, String postData, String cookie, String script, Integer details, Integer html, Integer maxWait, String headers, String format, Integer shots, Integer shotInterval, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/batch/ceate".replaceAll("\\{format\\}","json");

        List<Pair> localVarQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();
        if (instanceId != null)
        localVarFormParams.put("instance_id", instanceId);
        if (file != null)
        localVarFormParams.put("file", file);
        if (size != null)
        localVarFormParams.put("size", size);
        if (name != null)
        localVarFormParams.put("name", name);
        if (width != null)
        localVarFormParams.put("width", width);
        if (height != null)
        localVarFormParams.put("height", height);
        if (delay != null)
        localVarFormParams.put("delay", delay);
        if (flashDelay != null)
        localVarFormParams.put("flash_delay", flashDelay);
        if (screenWidth != null)
        localVarFormParams.put("screen_width", screenWidth);
        if (screenHeight != null)
        localVarFormParams.put("screen_height", screenHeight);
        if (priority != null)
        localVarFormParams.put("priority", priority);
        if (referer != null)
        localVarFormParams.put("referer", referer);
        if (postData != null)
        localVarFormParams.put("post_data", postData);
        if (cookie != null)
        localVarFormParams.put("cookie", cookie);
        if (script != null)
        localVarFormParams.put("script", script);
        if (details != null)
        localVarFormParams.put("details", details);
        if (html != null)
        localVarFormParams.put("html", html);
        if (maxWait != null)
        localVarFormParams.put("max_wait", maxWait);
        if (headers != null)
        localVarFormParams.put("headers", headers);
        if (format != null)
        localVarFormParams.put("format", format);
        if (shots != null)
        localVarFormParams.put("shots", shots);
        if (shotInterval != null)
        localVarFormParams.put("shot_interval", shotInterval);

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            "multipart/form-data"
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "apiKeyQuery" };
        return apiClient.buildCall(localVarPath, "POST", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call batchCeatePostValidateBeforeCall(Integer instanceId, File file, String size, String name, Integer width, Integer height, Integer delay, Integer flashDelay, Integer screenWidth, Integer screenHeight, Integer priority, String referer, String postData, String cookie, String script, Integer details, Integer html, Integer maxWait, String headers, String format, Integer shots, Integer shotInterval, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'instanceId' is set
        if (instanceId == null) {
            throw new ApiException("Missing the required parameter 'instanceId' when calling batchCeatePost(Async)");
        }
        
        
        com.squareup.okhttp.Call call = batchCeatePostCall(instanceId, file, size, name, width, height, delay, flashDelay, screenWidth, screenHeight, priority, referer, postData, cookie, script, details, html, maxWait, headers, format, shots, shotInterval, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Requests thousands of screenshtos at once
     * Get hundreds or thousands of screenshots from a text file. You can use this API call or the dashboard. Unlike the other API calls, you must issue a POST request with the Content-Type \&quot;multipart/form-data\&quot; in order to upload the text file. The text file must contain the list of URLs to request, 1 URL per line. Failed screenshots will be tried up to 3 times before giving up. 
     * @param instanceId instance ID to use (required)
     * @param file text file to use (optional)
     * @param size screenshots size - \&quot;screen\&quot; (default) or \&quot;page\&quot; (optional, default to screen)
     * @param name name of the batch (optional)
     * @param width thumbnail width. (optional, default to 1024)
     * @param height thumbnail height (optional)
     * @param delay number of seconds to wait after the page has loaded. This is used to let JavaScript run longer before taking the screenshot. Use delay&#x3D;0 to take screenshots faster. (optional, default to 5)
     * @param flashDelay number of seconds to wait after the page has loaded if Flash elements are present. Use flash_delay&#x3D;0 to take screenshots faster. (optional, default to 10)
     * @param screenWidth width of the browser window. For desktop browsers only. (optional, default to 1024)
     * @param screenHeight height of the browser window. For desktop browsers only. (Note: full-page screenshots can have a height of up to 15,000px) (optional, default to 768)
     * @param priority assign priority to the screenshot (for private instances only) (optional)
     * @param referer use a custom referrer header - paid screenshots only (optional)
     * @param postData send a POST requests with post_data, useful for filling out forms - paid screenshots only (optional)
     * @param cookie set a cookie for the URL requested (see Custom POST Data, Referer and Cookie) Cookies should be separated by a ; - paid screenshots only (optional)
     * @param script URL of javascript file to execute after the page load event (optional)
     * @param details level of information available with screenshot/info (optional, default to 2)
     * @param html saves the HTML of the rendered page which can be retrieved by the API call screenshot/html. This feature costs *1 credit* per screenshot. (optional, default to 0)
     * @param maxWait maximum number of seconds to wait before triggering the PageLoad event. Note that delay will still be used. (default: 0 &#x3D; disabled) (optional, default to 0)
     * @param headers any custom HTTP headers. (Not supported with Internet Explorer) (optional)
     * @param format image as PNG or JPEG (optional, default to png)
     * @param shots take multiple screenshots of the same page. This costs 1 additional credit for every 2 additional screenshots. (optional, default to 1)
     * @param shotInterval number of seconds between 2 screenshots (optional, default to 5)
     * @return List&lt;Batch&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<Batch> batchCeatePost(Integer instanceId, File file, String size, String name, Integer width, Integer height, Integer delay, Integer flashDelay, Integer screenWidth, Integer screenHeight, Integer priority, String referer, String postData, String cookie, String script, Integer details, Integer html, Integer maxWait, String headers, String format, Integer shots, Integer shotInterval) throws ApiException {
        ApiResponse<List<Batch>> resp = batchCeatePostWithHttpInfo(instanceId, file, size, name, width, height, delay, flashDelay, screenWidth, screenHeight, priority, referer, postData, cookie, script, details, html, maxWait, headers, format, shots, shotInterval);
        return resp.getData();
    }

    /**
     * Requests thousands of screenshtos at once
     * Get hundreds or thousands of screenshots from a text file. You can use this API call or the dashboard. Unlike the other API calls, you must issue a POST request with the Content-Type \&quot;multipart/form-data\&quot; in order to upload the text file. The text file must contain the list of URLs to request, 1 URL per line. Failed screenshots will be tried up to 3 times before giving up. 
     * @param instanceId instance ID to use (required)
     * @param file text file to use (optional)
     * @param size screenshots size - \&quot;screen\&quot; (default) or \&quot;page\&quot; (optional, default to screen)
     * @param name name of the batch (optional)
     * @param width thumbnail width. (optional, default to 1024)
     * @param height thumbnail height (optional)
     * @param delay number of seconds to wait after the page has loaded. This is used to let JavaScript run longer before taking the screenshot. Use delay&#x3D;0 to take screenshots faster. (optional, default to 5)
     * @param flashDelay number of seconds to wait after the page has loaded if Flash elements are present. Use flash_delay&#x3D;0 to take screenshots faster. (optional, default to 10)
     * @param screenWidth width of the browser window. For desktop browsers only. (optional, default to 1024)
     * @param screenHeight height of the browser window. For desktop browsers only. (Note: full-page screenshots can have a height of up to 15,000px) (optional, default to 768)
     * @param priority assign priority to the screenshot (for private instances only) (optional)
     * @param referer use a custom referrer header - paid screenshots only (optional)
     * @param postData send a POST requests with post_data, useful for filling out forms - paid screenshots only (optional)
     * @param cookie set a cookie for the URL requested (see Custom POST Data, Referer and Cookie) Cookies should be separated by a ; - paid screenshots only (optional)
     * @param script URL of javascript file to execute after the page load event (optional)
     * @param details level of information available with screenshot/info (optional, default to 2)
     * @param html saves the HTML of the rendered page which can be retrieved by the API call screenshot/html. This feature costs *1 credit* per screenshot. (optional, default to 0)
     * @param maxWait maximum number of seconds to wait before triggering the PageLoad event. Note that delay will still be used. (default: 0 &#x3D; disabled) (optional, default to 0)
     * @param headers any custom HTTP headers. (Not supported with Internet Explorer) (optional)
     * @param format image as PNG or JPEG (optional, default to png)
     * @param shots take multiple screenshots of the same page. This costs 1 additional credit for every 2 additional screenshots. (optional, default to 1)
     * @param shotInterval number of seconds between 2 screenshots (optional, default to 5)
     * @return ApiResponse&lt;List&lt;Batch&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<Batch>> batchCeatePostWithHttpInfo(Integer instanceId, File file, String size, String name, Integer width, Integer height, Integer delay, Integer flashDelay, Integer screenWidth, Integer screenHeight, Integer priority, String referer, String postData, String cookie, String script, Integer details, Integer html, Integer maxWait, String headers, String format, Integer shots, Integer shotInterval) throws ApiException {
        com.squareup.okhttp.Call call = batchCeatePostValidateBeforeCall(instanceId, file, size, name, width, height, delay, flashDelay, screenWidth, screenHeight, priority, referer, postData, cookie, script, details, html, maxWait, headers, format, shots, shotInterval, null, null);
        Type localVarReturnType = new TypeToken<List<Batch>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Requests thousands of screenshtos at once (asynchronously)
     * Get hundreds or thousands of screenshots from a text file. You can use this API call or the dashboard. Unlike the other API calls, you must issue a POST request with the Content-Type \&quot;multipart/form-data\&quot; in order to upload the text file. The text file must contain the list of URLs to request, 1 URL per line. Failed screenshots will be tried up to 3 times before giving up. 
     * @param instanceId instance ID to use (required)
     * @param file text file to use (optional)
     * @param size screenshots size - \&quot;screen\&quot; (default) or \&quot;page\&quot; (optional, default to screen)
     * @param name name of the batch (optional)
     * @param width thumbnail width. (optional, default to 1024)
     * @param height thumbnail height (optional)
     * @param delay number of seconds to wait after the page has loaded. This is used to let JavaScript run longer before taking the screenshot. Use delay&#x3D;0 to take screenshots faster. (optional, default to 5)
     * @param flashDelay number of seconds to wait after the page has loaded if Flash elements are present. Use flash_delay&#x3D;0 to take screenshots faster. (optional, default to 10)
     * @param screenWidth width of the browser window. For desktop browsers only. (optional, default to 1024)
     * @param screenHeight height of the browser window. For desktop browsers only. (Note: full-page screenshots can have a height of up to 15,000px) (optional, default to 768)
     * @param priority assign priority to the screenshot (for private instances only) (optional)
     * @param referer use a custom referrer header - paid screenshots only (optional)
     * @param postData send a POST requests with post_data, useful for filling out forms - paid screenshots only (optional)
     * @param cookie set a cookie for the URL requested (see Custom POST Data, Referer and Cookie) Cookies should be separated by a ; - paid screenshots only (optional)
     * @param script URL of javascript file to execute after the page load event (optional)
     * @param details level of information available with screenshot/info (optional, default to 2)
     * @param html saves the HTML of the rendered page which can be retrieved by the API call screenshot/html. This feature costs *1 credit* per screenshot. (optional, default to 0)
     * @param maxWait maximum number of seconds to wait before triggering the PageLoad event. Note that delay will still be used. (default: 0 &#x3D; disabled) (optional, default to 0)
     * @param headers any custom HTTP headers. (Not supported with Internet Explorer) (optional)
     * @param format image as PNG or JPEG (optional, default to png)
     * @param shots take multiple screenshots of the same page. This costs 1 additional credit for every 2 additional screenshots. (optional, default to 1)
     * @param shotInterval number of seconds between 2 screenshots (optional, default to 5)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call batchCeatePostAsync(Integer instanceId, File file, String size, String name, Integer width, Integer height, Integer delay, Integer flashDelay, Integer screenWidth, Integer screenHeight, Integer priority, String referer, String postData, String cookie, String script, Integer details, Integer html, Integer maxWait, String headers, String format, Integer shots, Integer shotInterval, final ApiCallback<List<Batch>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = batchCeatePostValidateBeforeCall(instanceId, file, size, name, width, height, delay, flashDelay, screenWidth, screenHeight, priority, referer, postData, cookie, script, details, html, maxWait, headers, format, shots, shotInterval, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<Batch>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for batchInfoGet */
    private com.squareup.okhttp.Call batchInfoGetCall(Integer id, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/batch/info".replaceAll("\\{format\\}","json");

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (id != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "id", id));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "apiKeyQuery" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call batchInfoGetValidateBeforeCall(Integer id, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling batchInfoGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = batchInfoGetCall(id, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Get the batch status
     * Get the status of a batch requested through the API or through the dashboard. 
     * @param id batch ID (required)
     * @return Batch
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Batch batchInfoGet(Integer id) throws ApiException {
        ApiResponse<Batch> resp = batchInfoGetWithHttpInfo(id);
        return resp.getData();
    }

    /**
     * Get the batch status
     * Get the status of a batch requested through the API or through the dashboard. 
     * @param id batch ID (required)
     * @return ApiResponse&lt;Batch&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Batch> batchInfoGetWithHttpInfo(Integer id) throws ApiException {
        com.squareup.okhttp.Call call = batchInfoGetValidateBeforeCall(id, null, null);
        Type localVarReturnType = new TypeToken<Batch>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get the batch status (asynchronously)
     * Get the status of a batch requested through the API or through the dashboard. 
     * @param id batch ID (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call batchInfoGetAsync(Integer id, final ApiCallback<Batch> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = batchInfoGetValidateBeforeCall(id, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<Batch>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
