/*
 * Browshot API
 * Take screenshots of any website in real time
 *
 * OpenAPI spec version: 1.16.0
 * Contact: support@browshot.com
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */


package io.swagger.client.api;

import io.swagger.client.ApiCallback;
import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import io.swagger.client.model.Screenshot;
import io.swagger.client.model.ScreenshotError;
import io.swagger.client.model.ScreenshotHost;
import io.swagger.client.model.ScreenshotInfoError;
import io.swagger.client.model.ScreenshotList;
import io.swagger.client.model.ScreenshotShort;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class ScreenshotApi {
    private ApiClient apiClient;

    public ScreenshotApi() {
        this(Configuration.getDefaultApiClient());
    }

    public ScreenshotApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    /* Build call for screenshotCreateGet */
    private com.squareup.okhttp.Call screenshotCreateGetCall(String url, Integer instanceId, String size, Integer cache, Integer delay, Integer flashDelay, Integer screenWidth, Integer screenHeight, Integer priority, String referer, String postData, String cookie, String script, Integer details, Integer html, Integer maxWait, String headers, Integer shots, Integer shotInterval, String hosting, Integer hostingHeight, Integer hostingWidth, Float hostingScale, String hostingBucket, String hostingFile, String hostingHeaders, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/screenshot/create".replaceAll("\\{format\\}","json");

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (url != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "url", url));
        if (instanceId != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "instance_id", instanceId));
        if (size != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "size", size));
        if (cache != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "cache", cache));
        if (delay != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "delay", delay));
        if (flashDelay != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "flash_delay", flashDelay));
        if (screenWidth != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "screen_width", screenWidth));
        if (screenHeight != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "screen_height", screenHeight));
        if (priority != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "priority", priority));
        if (referer != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "referer", referer));
        if (postData != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "post_data", postData));
        if (cookie != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "cookie", cookie));
        if (script != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "script", script));
        if (details != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "details", details));
        if (html != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "html", html));
        if (maxWait != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "max_wait", maxWait));
        if (headers != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "headers", headers));
        if (shots != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "shots", shots));
        if (shotInterval != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "shot_interval", shotInterval));
        if (hosting != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "hosting", hosting));
        if (hostingHeight != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "hosting_height", hostingHeight));
        if (hostingWidth != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "hosting_width", hostingWidth));
        if (hostingScale != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "hosting_scale", hostingScale));
        if (hostingBucket != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "hosting_bucket", hostingBucket));
        if (hostingFile != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "hosting_file", hostingFile));
        if (hostingHeaders != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "hosting_headers", hostingHeaders));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "apiKeyQuery" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call screenshotCreateGetValidateBeforeCall(String url, Integer instanceId, String size, Integer cache, Integer delay, Integer flashDelay, Integer screenWidth, Integer screenHeight, Integer priority, String referer, String postData, String cookie, String script, Integer details, Integer html, Integer maxWait, String headers, Integer shots, Integer shotInterval, String hosting, Integer hostingHeight, Integer hostingWidth, Float hostingScale, String hostingBucket, String hostingFile, String hostingHeaders, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'url' is set
        if (url == null) {
            throw new ApiException("Missing the required parameter 'url' when calling screenshotCreateGet(Async)");
        }
        
        // verify the required parameter 'instanceId' is set
        if (instanceId == null) {
            throw new ApiException("Missing the required parameter 'instanceId' when calling screenshotCreateGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = screenshotCreateGetCall(url, instanceId, size, cache, delay, flashDelay, screenWidth, screenHeight, priority, referer, postData, cookie, script, details, html, maxWait, headers, shots, shotInterval, hosting, hostingHeight, hostingWidth, hostingScale, hostingBucket, hostingFile, hostingHeaders, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Request a screenshot
     * Screenshots requests to private and shared instances require a positive balance.  *IMPORTANT*: Remember that you can only do 100 free screenshots per month. To used a premium instance, use instance_id&#x3D;65 for example. 
     * @param url URL of the page to get a screenshot for (required)
     * @param instanceId instance ID to use (required)
     * @param size screenshot size - \&quot;screen\&quot; (default) or \&quot;page\&quot; (optional, default to screen)
     * @param cache use a previous screenshot (same URL, same instance) if it was done within &lt;cache_value&gt; seconds. The default value is 24hours. Specify cache&#x3D;0 if you want a new screenshot. (optional, default to 86400)
     * @param delay number of seconds to wait after the page has loaded. This is used to let JavaScript run longer before taking the screenshot. Use delay&#x3D;0 to take screenshots faster. (optional, default to 5)
     * @param flashDelay number of seconds to wait after the page has loaded if Flash elements are present. Use flash_delay&#x3D;0 to take screenshots faster. (optional, default to 10)
     * @param screenWidth width of the browser window. For desktop browsers only. (optional, default to 1024)
     * @param screenHeight height of the browser window. For desktop browsers only. (Note: full-page screenshots can have a height of up to 15,000px) (optional, default to 768)
     * @param priority assign priority to the screenshot (for private instances only) (optional)
     * @param referer use a custom referrer header - paid screenshots only (optional)
     * @param postData send a POST requests with post_data, useful for filling out forms - paid screenshots only (optional)
     * @param cookie set a cookie for the URL requested (see Custom POST Data, Referer and Cookie) Cookies should be separated by a ; - paid screenshots only (optional)
     * @param script URL of javascript file to execute after the page load event (optional)
     * @param details level of information available with screenshot/info (optional, default to 2)
     * @param html saves the HTML of the rendered page which can be retrieved by the API call screenshot/html. This feature costs *1 credit* per screenshot. (optional, default to 0)
     * @param maxWait maximum number of seconds to wait before triggering the PageLoad event. Note that delay will still be used. (default: 0 &#x3D; disabled) (optional, default to 0)
     * @param headers any custom HTTP headers. (Not supported with Internet Explorer) (optional)
     * @param shots take multiple screenshots of the same page. This costs 1 additional credit for every 2 additional screenshots. (optional, default to 1)
     * @param shotInterval number of seconds between 2 screenshots (optional, default to 5)
     * @param hosting hosting option - s3 or browshot (optional)
     * @param hostingHeight maximum height of the thumbnail to host (optional)
     * @param hostingWidth maximum height of the thumbnail to host (optional)
     * @param hostingScale scale of the thumbnail to host (optional, default to 1)
     * @param hostingBucket S3 bucket to upload the screenshot or thumbnail (required for S3) (optional)
     * @param hostingFile file name to use (for S3 only) (optional)
     * @param hostingHeaders list of headers to add to the S3 object (for S3 only) (optional)
     * @return Screenshot
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public Screenshot screenshotCreateGet(String url, Integer instanceId, String size, Integer cache, Integer delay, Integer flashDelay, Integer screenWidth, Integer screenHeight, Integer priority, String referer, String postData, String cookie, String script, Integer details, Integer html, Integer maxWait, String headers, Integer shots, Integer shotInterval, String hosting, Integer hostingHeight, Integer hostingWidth, Float hostingScale, String hostingBucket, String hostingFile, String hostingHeaders) throws ApiException {
        ApiResponse<Screenshot> resp = screenshotCreateGetWithHttpInfo(url, instanceId, size, cache, delay, flashDelay, screenWidth, screenHeight, priority, referer, postData, cookie, script, details, html, maxWait, headers, shots, shotInterval, hosting, hostingHeight, hostingWidth, hostingScale, hostingBucket, hostingFile, hostingHeaders);
        return resp.getData();
    }

    /**
     * Request a screenshot
     * Screenshots requests to private and shared instances require a positive balance.  *IMPORTANT*: Remember that you can only do 100 free screenshots per month. To used a premium instance, use instance_id&#x3D;65 for example. 
     * @param url URL of the page to get a screenshot for (required)
     * @param instanceId instance ID to use (required)
     * @param size screenshot size - \&quot;screen\&quot; (default) or \&quot;page\&quot; (optional, default to screen)
     * @param cache use a previous screenshot (same URL, same instance) if it was done within &lt;cache_value&gt; seconds. The default value is 24hours. Specify cache&#x3D;0 if you want a new screenshot. (optional, default to 86400)
     * @param delay number of seconds to wait after the page has loaded. This is used to let JavaScript run longer before taking the screenshot. Use delay&#x3D;0 to take screenshots faster. (optional, default to 5)
     * @param flashDelay number of seconds to wait after the page has loaded if Flash elements are present. Use flash_delay&#x3D;0 to take screenshots faster. (optional, default to 10)
     * @param screenWidth width of the browser window. For desktop browsers only. (optional, default to 1024)
     * @param screenHeight height of the browser window. For desktop browsers only. (Note: full-page screenshots can have a height of up to 15,000px) (optional, default to 768)
     * @param priority assign priority to the screenshot (for private instances only) (optional)
     * @param referer use a custom referrer header - paid screenshots only (optional)
     * @param postData send a POST requests with post_data, useful for filling out forms - paid screenshots only (optional)
     * @param cookie set a cookie for the URL requested (see Custom POST Data, Referer and Cookie) Cookies should be separated by a ; - paid screenshots only (optional)
     * @param script URL of javascript file to execute after the page load event (optional)
     * @param details level of information available with screenshot/info (optional, default to 2)
     * @param html saves the HTML of the rendered page which can be retrieved by the API call screenshot/html. This feature costs *1 credit* per screenshot. (optional, default to 0)
     * @param maxWait maximum number of seconds to wait before triggering the PageLoad event. Note that delay will still be used. (default: 0 &#x3D; disabled) (optional, default to 0)
     * @param headers any custom HTTP headers. (Not supported with Internet Explorer) (optional)
     * @param shots take multiple screenshots of the same page. This costs 1 additional credit for every 2 additional screenshots. (optional, default to 1)
     * @param shotInterval number of seconds between 2 screenshots (optional, default to 5)
     * @param hosting hosting option - s3 or browshot (optional)
     * @param hostingHeight maximum height of the thumbnail to host (optional)
     * @param hostingWidth maximum height of the thumbnail to host (optional)
     * @param hostingScale scale of the thumbnail to host (optional, default to 1)
     * @param hostingBucket S3 bucket to upload the screenshot or thumbnail (required for S3) (optional)
     * @param hostingFile file name to use (for S3 only) (optional)
     * @param hostingHeaders list of headers to add to the S3 object (for S3 only) (optional)
     * @return ApiResponse&lt;Screenshot&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Screenshot> screenshotCreateGetWithHttpInfo(String url, Integer instanceId, String size, Integer cache, Integer delay, Integer flashDelay, Integer screenWidth, Integer screenHeight, Integer priority, String referer, String postData, String cookie, String script, Integer details, Integer html, Integer maxWait, String headers, Integer shots, Integer shotInterval, String hosting, Integer hostingHeight, Integer hostingWidth, Float hostingScale, String hostingBucket, String hostingFile, String hostingHeaders) throws ApiException {
        com.squareup.okhttp.Call call = screenshotCreateGetValidateBeforeCall(url, instanceId, size, cache, delay, flashDelay, screenWidth, screenHeight, priority, referer, postData, cookie, script, details, html, maxWait, headers, shots, shotInterval, hosting, hostingHeight, hostingWidth, hostingScale, hostingBucket, hostingFile, hostingHeaders, null, null);
        Type localVarReturnType = new TypeToken<Screenshot>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Request a screenshot (asynchronously)
     * Screenshots requests to private and shared instances require a positive balance.  *IMPORTANT*: Remember that you can only do 100 free screenshots per month. To used a premium instance, use instance_id&#x3D;65 for example. 
     * @param url URL of the page to get a screenshot for (required)
     * @param instanceId instance ID to use (required)
     * @param size screenshot size - \&quot;screen\&quot; (default) or \&quot;page\&quot; (optional, default to screen)
     * @param cache use a previous screenshot (same URL, same instance) if it was done within &lt;cache_value&gt; seconds. The default value is 24hours. Specify cache&#x3D;0 if you want a new screenshot. (optional, default to 86400)
     * @param delay number of seconds to wait after the page has loaded. This is used to let JavaScript run longer before taking the screenshot. Use delay&#x3D;0 to take screenshots faster. (optional, default to 5)
     * @param flashDelay number of seconds to wait after the page has loaded if Flash elements are present. Use flash_delay&#x3D;0 to take screenshots faster. (optional, default to 10)
     * @param screenWidth width of the browser window. For desktop browsers only. (optional, default to 1024)
     * @param screenHeight height of the browser window. For desktop browsers only. (Note: full-page screenshots can have a height of up to 15,000px) (optional, default to 768)
     * @param priority assign priority to the screenshot (for private instances only) (optional)
     * @param referer use a custom referrer header - paid screenshots only (optional)
     * @param postData send a POST requests with post_data, useful for filling out forms - paid screenshots only (optional)
     * @param cookie set a cookie for the URL requested (see Custom POST Data, Referer and Cookie) Cookies should be separated by a ; - paid screenshots only (optional)
     * @param script URL of javascript file to execute after the page load event (optional)
     * @param details level of information available with screenshot/info (optional, default to 2)
     * @param html saves the HTML of the rendered page which can be retrieved by the API call screenshot/html. This feature costs *1 credit* per screenshot. (optional, default to 0)
     * @param maxWait maximum number of seconds to wait before triggering the PageLoad event. Note that delay will still be used. (default: 0 &#x3D; disabled) (optional, default to 0)
     * @param headers any custom HTTP headers. (Not supported with Internet Explorer) (optional)
     * @param shots take multiple screenshots of the same page. This costs 1 additional credit for every 2 additional screenshots. (optional, default to 1)
     * @param shotInterval number of seconds between 2 screenshots (optional, default to 5)
     * @param hosting hosting option - s3 or browshot (optional)
     * @param hostingHeight maximum height of the thumbnail to host (optional)
     * @param hostingWidth maximum height of the thumbnail to host (optional)
     * @param hostingScale scale of the thumbnail to host (optional, default to 1)
     * @param hostingBucket S3 bucket to upload the screenshot or thumbnail (required for S3) (optional)
     * @param hostingFile file name to use (for S3 only) (optional)
     * @param hostingHeaders list of headers to add to the S3 object (for S3 only) (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call screenshotCreateGetAsync(String url, Integer instanceId, String size, Integer cache, Integer delay, Integer flashDelay, Integer screenWidth, Integer screenHeight, Integer priority, String referer, String postData, String cookie, String script, Integer details, Integer html, Integer maxWait, String headers, Integer shots, Integer shotInterval, String hosting, Integer hostingHeight, Integer hostingWidth, Float hostingScale, String hostingBucket, String hostingFile, String hostingHeaders, final ApiCallback<Screenshot> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = screenshotCreateGetValidateBeforeCall(url, instanceId, size, cache, delay, flashDelay, screenWidth, screenHeight, priority, referer, postData, cookie, script, details, html, maxWait, headers, shots, shotInterval, hosting, hostingHeight, hostingWidth, hostingScale, hostingBucket, hostingFile, hostingHeaders, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<Screenshot>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for screenshotDeleteGet */
    private com.squareup.okhttp.Call screenshotDeleteGetCall(Integer id, String data, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/screenshot/delete".replaceAll("\\{format\\}","json");

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (id != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "id", id));
        if (data != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "data", data));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "apiKeyQuery" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call screenshotDeleteGetValidateBeforeCall(Integer id, String data, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling screenshotDeleteGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = screenshotDeleteGetCall(id, data, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Delete screenshot data
     * You can delete details of your screenshots to remove any confidential information. 
     * @param id screenshot ID (required)
     * @param data data to remove. You can specify multiple of them (separated by a ,): *image* (image files), *url* (url requested), *metadata* (time added, time finished, post data, cookie and referer used for the screenshot), *all* (all data and files)  (optional, default to image)
     * @return List&lt;ScreenshotShort&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<ScreenshotShort> screenshotDeleteGet(Integer id, String data) throws ApiException {
        ApiResponse<List<ScreenshotShort>> resp = screenshotDeleteGetWithHttpInfo(id, data);
        return resp.getData();
    }

    /**
     * Delete screenshot data
     * You can delete details of your screenshots to remove any confidential information. 
     * @param id screenshot ID (required)
     * @param data data to remove. You can specify multiple of them (separated by a ,): *image* (image files), *url* (url requested), *metadata* (time added, time finished, post data, cookie and referer used for the screenshot), *all* (all data and files)  (optional, default to image)
     * @return ApiResponse&lt;List&lt;ScreenshotShort&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<ScreenshotShort>> screenshotDeleteGetWithHttpInfo(Integer id, String data) throws ApiException {
        com.squareup.okhttp.Call call = screenshotDeleteGetValidateBeforeCall(id, data, null, null);
        Type localVarReturnType = new TypeToken<List<ScreenshotShort>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Delete screenshot data (asynchronously)
     * You can delete details of your screenshots to remove any confidential information. 
     * @param id screenshot ID (required)
     * @param data data to remove. You can specify multiple of them (separated by a ,): *image* (image files), *url* (url requested), *metadata* (time added, time finished, post data, cookie and referer used for the screenshot), *all* (all data and files)  (optional, default to image)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call screenshotDeleteGetAsync(Integer id, String data, final ApiCallback<List<ScreenshotShort>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = screenshotDeleteGetValidateBeforeCall(id, data, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<ScreenshotShort>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for screenshotHostGet */
    private com.squareup.okhttp.Call screenshotHostGetCall(Integer id, String hosting, Integer width, Integer height, Double scale, String bucket, String file, String headers, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/screenshot/host".replaceAll("\\{format\\}","json");

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (id != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "id", id));
        if (hosting != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "hosting", hosting));
        if (width != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "width", width));
        if (height != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "height", height));
        if (scale != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "scale", scale));
        if (bucket != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "bucket", bucket));
        if (file != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "file", file));
        if (headers != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "headers", headers));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "apiKeyQuery" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call screenshotHostGetValidateBeforeCall(Integer id, String hosting, Integer width, Integer height, Double scale, String bucket, String file, String headers, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling screenshotHostGet(Async)");
        }
        
        // verify the required parameter 'hosting' is set
        if (hosting == null) {
            throw new ApiException("Missing the required parameter 'hosting' when calling screenshotHostGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = screenshotHostGetCall(id, hosting, width, height, scale, bucket, file, headers, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Host thumbnails on your own S3 account or on Browshot.
     * You can host screenshots and thumbnails on your own S3 account or on Browshot.
     * @param id screenshot ID (required)
     * @param hosting hosting option: s3 or browshot (required)
     * @param width width of the thumbnail (optional)
     * @param height height of the thumbnail (optional)
     * @param scale scale of the thumbnail (optional, default to 1)
     * @param bucket S3 bucket to upload the screenshot or thumbnail - required with hosting&#x3D;s3 (optional)
     * @param file file name to use - optional, used with hosting&#x3D;s3 (optional)
     * @param headers HTTP headers to add to your S3 object - optional, used with hosting&#x3D;s3 (optional)
     * @return List&lt;ScreenshotHost&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<ScreenshotHost> screenshotHostGet(Integer id, String hosting, Integer width, Integer height, Double scale, String bucket, String file, String headers) throws ApiException {
        ApiResponse<List<ScreenshotHost>> resp = screenshotHostGetWithHttpInfo(id, hosting, width, height, scale, bucket, file, headers);
        return resp.getData();
    }

    /**
     * Host thumbnails on your own S3 account or on Browshot.
     * You can host screenshots and thumbnails on your own S3 account or on Browshot.
     * @param id screenshot ID (required)
     * @param hosting hosting option: s3 or browshot (required)
     * @param width width of the thumbnail (optional)
     * @param height height of the thumbnail (optional)
     * @param scale scale of the thumbnail (optional, default to 1)
     * @param bucket S3 bucket to upload the screenshot or thumbnail - required with hosting&#x3D;s3 (optional)
     * @param file file name to use - optional, used with hosting&#x3D;s3 (optional)
     * @param headers HTTP headers to add to your S3 object - optional, used with hosting&#x3D;s3 (optional)
     * @return ApiResponse&lt;List&lt;ScreenshotHost&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<ScreenshotHost>> screenshotHostGetWithHttpInfo(Integer id, String hosting, Integer width, Integer height, Double scale, String bucket, String file, String headers) throws ApiException {
        com.squareup.okhttp.Call call = screenshotHostGetValidateBeforeCall(id, hosting, width, height, scale, bucket, file, headers, null, null);
        Type localVarReturnType = new TypeToken<List<ScreenshotHost>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Host thumbnails on your own S3 account or on Browshot. (asynchronously)
     * You can host screenshots and thumbnails on your own S3 account or on Browshot.
     * @param id screenshot ID (required)
     * @param hosting hosting option: s3 or browshot (required)
     * @param width width of the thumbnail (optional)
     * @param height height of the thumbnail (optional)
     * @param scale scale of the thumbnail (optional, default to 1)
     * @param bucket S3 bucket to upload the screenshot or thumbnail - required with hosting&#x3D;s3 (optional)
     * @param file file name to use - optional, used with hosting&#x3D;s3 (optional)
     * @param headers HTTP headers to add to your S3 object - optional, used with hosting&#x3D;s3 (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call screenshotHostGetAsync(Integer id, String hosting, Integer width, Integer height, Double scale, String bucket, String file, String headers, final ApiCallback<List<ScreenshotHost>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = screenshotHostGetValidateBeforeCall(id, hosting, width, height, scale, bucket, file, headers, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<ScreenshotHost>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for screenshotHtmlGet */
    private com.squareup.okhttp.Call screenshotHtmlGetCall(Integer id, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/screenshot/html".replaceAll("\\{format\\}","json");

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (id != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "id", id));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "text/html"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "apiKeyQuery" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call screenshotHtmlGetValidateBeforeCall(Integer id, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling screenshotHtmlGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = screenshotHtmlGetCall(id, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Get the HTML code
     * Retrieve the HTML code of the rendered page. This API call should be used when html&#x3D;1 was specified in the screenshot request. 
     * @param id screenshot ID (required)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void screenshotHtmlGet(Integer id) throws ApiException {
        screenshotHtmlGetWithHttpInfo(id);
    }

    /**
     * Get the HTML code
     * Retrieve the HTML code of the rendered page. This API call should be used when html&#x3D;1 was specified in the screenshot request. 
     * @param id screenshot ID (required)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> screenshotHtmlGetWithHttpInfo(Integer id) throws ApiException {
        com.squareup.okhttp.Call call = screenshotHtmlGetValidateBeforeCall(id, null, null);
        return apiClient.execute(call);
    }

    /**
     * Get the HTML code (asynchronously)
     * Retrieve the HTML code of the rendered page. This API call should be used when html&#x3D;1 was specified in the screenshot request. 
     * @param id screenshot ID (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call screenshotHtmlGetAsync(Integer id, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = screenshotHtmlGetValidateBeforeCall(id, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
    /* Build call for screenshotInfoGet */
    private com.squareup.okhttp.Call screenshotInfoGetCall(Integer id, Integer details, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/screenshot/info".replaceAll("\\{format\\}","json");

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (id != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "id", id));
        if (details != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "details", details));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "apiKeyQuery" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call screenshotInfoGetValidateBeforeCall(Integer id, Integer details, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling screenshotInfoGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = screenshotInfoGetCall(id, details, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Query screenshot status
     * Once a screenshot has been requested, its status must be checked until it is either \&quot;error\&quot; or \&quot;finished\&quot;.
     * @param id screenshot ID received from /api/v1/screenshot/create (required)
     * @param details level of details about the screenshot and the page (optional, default to 2)
     * @return List&lt;Screenshot&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<Screenshot> screenshotInfoGet(Integer id, Integer details) throws ApiException {
        ApiResponse<List<Screenshot>> resp = screenshotInfoGetWithHttpInfo(id, details);
        return resp.getData();
    }

    /**
     * Query screenshot status
     * Once a screenshot has been requested, its status must be checked until it is either \&quot;error\&quot; or \&quot;finished\&quot;.
     * @param id screenshot ID received from /api/v1/screenshot/create (required)
     * @param details level of details about the screenshot and the page (optional, default to 2)
     * @return ApiResponse&lt;List&lt;Screenshot&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<Screenshot>> screenshotInfoGetWithHttpInfo(Integer id, Integer details) throws ApiException {
        com.squareup.okhttp.Call call = screenshotInfoGetValidateBeforeCall(id, details, null, null);
        Type localVarReturnType = new TypeToken<List<Screenshot>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Query screenshot status (asynchronously)
     * Once a screenshot has been requested, its status must be checked until it is either \&quot;error\&quot; or \&quot;finished\&quot;.
     * @param id screenshot ID received from /api/v1/screenshot/create (required)
     * @param details level of details about the screenshot and the page (optional, default to 2)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call screenshotInfoGetAsync(Integer id, Integer details, final ApiCallback<List<Screenshot>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = screenshotInfoGetValidateBeforeCall(id, details, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<Screenshot>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for screenshotListGet */
    private com.squareup.okhttp.Call screenshotListGetCall(Integer limit, String status, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/screenshot/list".replaceAll("\\{format\\}","json");

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (limit != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "limit", limit));
        if (status != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "status", status));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "apiKeyQuery" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call screenshotListGetValidateBeforeCall(Integer limit, String status, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        
        com.squareup.okhttp.Call call = screenshotListGetCall(limit, status, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Get information about the last 100 screenshots requested.
     * Get information about the last 100 screenshots requested.
     * @param limit maximum number of screenshots&#39; information to return (optional, default to 100)
     * @param status get list of screenshot in a given status (error, finished, in_process) (optional)
     * @return List&lt;ScreenshotList&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<ScreenshotList> screenshotListGet(Integer limit, String status) throws ApiException {
        ApiResponse<List<ScreenshotList>> resp = screenshotListGetWithHttpInfo(limit, status);
        return resp.getData();
    }

    /**
     * Get information about the last 100 screenshots requested.
     * Get information about the last 100 screenshots requested.
     * @param limit maximum number of screenshots&#39; information to return (optional, default to 100)
     * @param status get list of screenshot in a given status (error, finished, in_process) (optional)
     * @return ApiResponse&lt;List&lt;ScreenshotList&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<ScreenshotList>> screenshotListGetWithHttpInfo(Integer limit, String status) throws ApiException {
        com.squareup.okhttp.Call call = screenshotListGetValidateBeforeCall(limit, status, null, null);
        Type localVarReturnType = new TypeToken<List<ScreenshotList>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get information about the last 100 screenshots requested. (asynchronously)
     * Get information about the last 100 screenshots requested.
     * @param limit maximum number of screenshots&#39; information to return (optional, default to 100)
     * @param status get list of screenshot in a given status (error, finished, in_process) (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call screenshotListGetAsync(Integer limit, String status, final ApiCallback<List<ScreenshotList>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = screenshotListGetValidateBeforeCall(limit, status, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<ScreenshotList>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for screenshotMultipleGet */
    private com.squareup.okhttp.Call screenshotMultipleGetCall(String url, Integer instanceId, String size, Integer cache, Integer delay, Integer flashDelay, Integer screenWidth, Integer screenHeight, Integer priority, String referer, String postData, String cookie, String script, Integer details, Integer html, Integer maxWait, String headers, String hosting, Integer hostingHeight, Integer hostingWidth, Float hostingScale, String hostingBucket, String hostingFile, String hostingHeaders, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/screenshot/multiple".replaceAll("\\{format\\}","json");

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (url != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "url", url));
        if (instanceId != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "instance_id", instanceId));
        if (size != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "size", size));
        if (cache != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "cache", cache));
        if (delay != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "delay", delay));
        if (flashDelay != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "flash_delay", flashDelay));
        if (screenWidth != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "screen_width", screenWidth));
        if (screenHeight != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "screen_height", screenHeight));
        if (priority != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "priority", priority));
        if (referer != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "referer", referer));
        if (postData != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "post_data", postData));
        if (cookie != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "cookie", cookie));
        if (script != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "script", script));
        if (details != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "details", details));
        if (html != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "html", html));
        if (maxWait != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "max_wait", maxWait));
        if (headers != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "headers", headers));
        if (hosting != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "hosting", hosting));
        if (hostingHeight != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "hosting_height", hostingHeight));
        if (hostingWidth != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "hosting_width", hostingWidth));
        if (hostingScale != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "hosting_scale", hostingScale));
        if (hostingBucket != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "hosting_bucket", hostingBucket));
        if (hostingFile != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "hosting_file", hostingFile));
        if (hostingHeaders != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "hosting_headers", hostingHeaders));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "apiKeyQuery" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call screenshotMultipleGetValidateBeforeCall(String url, Integer instanceId, String size, Integer cache, Integer delay, Integer flashDelay, Integer screenWidth, Integer screenHeight, Integer priority, String referer, String postData, String cookie, String script, Integer details, Integer html, Integer maxWait, String headers, String hosting, Integer hostingHeight, Integer hostingWidth, Float hostingScale, String hostingBucket, String hostingFile, String hostingHeaders, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'url' is set
        if (url == null) {
            throw new ApiException("Missing the required parameter 'url' when calling screenshotMultipleGet(Async)");
        }
        
        // verify the required parameter 'instanceId' is set
        if (instanceId == null) {
            throw new ApiException("Missing the required parameter 'instanceId' when calling screenshotMultipleGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = screenshotMultipleGetCall(url, instanceId, size, cache, delay, flashDelay, screenWidth, screenHeight, priority, referer, postData, cookie, script, details, html, maxWait, headers, hosting, hostingHeight, hostingWidth, hostingScale, hostingBucket, hostingFile, hostingHeaders, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Request multiple screenshots
     * Request multiple screenshots in one API call. The API call accepts all the parameters supported by screenshot/create. You can specify up to 10 URLs and 10 instances for a total of 100 screenshots in one API call. 
     * @param url URL of the page to get a screenshot for. You can specify multiple url parameters (up to 10). (required)
     * @param instanceId instance ID to use. You can specify multiple instance_id parameters (up to 10). (required)
     * @param size screenshot size - \&quot;screen\&quot; (default) or \&quot;page\&quot; (optional, default to screen)
     * @param cache use a previous screenshot (same URL, same instance) if it was done within &lt;cache_value&gt; seconds. The default value is 24hours. Specify cache&#x3D;0 if you want a new screenshot. (optional, default to 86400)
     * @param delay number of seconds to wait after the page has loaded. This is used to let JavaScript run longer before taking the screenshot. Use delay&#x3D;0 to take screenshots faster. (optional, default to 5)
     * @param flashDelay number of seconds to wait after the page has loaded if Flash elements are present. Use flash_delay&#x3D;0 to take screenshots faster. (optional, default to 10)
     * @param screenWidth width of the browser window. For desktop browsers only. (optional, default to 1024)
     * @param screenHeight height of the browser window. For desktop browsers only. (Note: full-page screenshots can have a height of up to 15,000px) (optional, default to 768)
     * @param priority assign priority to the screenshot (for private instances only) (optional)
     * @param referer use a custom referrer header - paid screenshots only (optional)
     * @param postData send a POST requests with post_data, useful for filling out forms - paid screenshots only (optional)
     * @param cookie set a cookie for the URL requested (see Custom POST Data, Referer and Cookie) Cookies should be separated by a ; - paid screenshots only (optional)
     * @param script URL of javascript file to execute after the page load event (optional)
     * @param details level of information available with screenshot/info (optional, default to 2)
     * @param html saves the HTML of the rendered page which can be retrieved by the API call screenshot/html. This feature costs *1 credit* per screenshot. (optional, default to 0)
     * @param maxWait maximum number of seconds to wait before triggering the PageLoad event. Note that delay will still be used. (default: 0 &#x3D; disabled) (optional, default to 0)
     * @param headers any custom HTTP headers. (Not supported with Internet Explorer) (optional)
     * @param hosting hosting option - s3 or browshot (optional)
     * @param hostingHeight maximum height of the thumbnail to host (optional)
     * @param hostingWidth maximum height of the thumbnail to host (optional)
     * @param hostingScale scale of the thumbnail to host (optional, default to 1)
     * @param hostingBucket S3 bucket to upload the screenshot or thumbnail (required for S3) (optional)
     * @param hostingFile file name to use (for S3 only) (optional)
     * @param hostingHeaders list of headers to add to the S3 object (for S3 only) (optional)
     * @return ScreenshotList
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ScreenshotList screenshotMultipleGet(String url, Integer instanceId, String size, Integer cache, Integer delay, Integer flashDelay, Integer screenWidth, Integer screenHeight, Integer priority, String referer, String postData, String cookie, String script, Integer details, Integer html, Integer maxWait, String headers, String hosting, Integer hostingHeight, Integer hostingWidth, Float hostingScale, String hostingBucket, String hostingFile, String hostingHeaders) throws ApiException {
        ApiResponse<ScreenshotList> resp = screenshotMultipleGetWithHttpInfo(url, instanceId, size, cache, delay, flashDelay, screenWidth, screenHeight, priority, referer, postData, cookie, script, details, html, maxWait, headers, hosting, hostingHeight, hostingWidth, hostingScale, hostingBucket, hostingFile, hostingHeaders);
        return resp.getData();
    }

    /**
     * Request multiple screenshots
     * Request multiple screenshots in one API call. The API call accepts all the parameters supported by screenshot/create. You can specify up to 10 URLs and 10 instances for a total of 100 screenshots in one API call. 
     * @param url URL of the page to get a screenshot for. You can specify multiple url parameters (up to 10). (required)
     * @param instanceId instance ID to use. You can specify multiple instance_id parameters (up to 10). (required)
     * @param size screenshot size - \&quot;screen\&quot; (default) or \&quot;page\&quot; (optional, default to screen)
     * @param cache use a previous screenshot (same URL, same instance) if it was done within &lt;cache_value&gt; seconds. The default value is 24hours. Specify cache&#x3D;0 if you want a new screenshot. (optional, default to 86400)
     * @param delay number of seconds to wait after the page has loaded. This is used to let JavaScript run longer before taking the screenshot. Use delay&#x3D;0 to take screenshots faster. (optional, default to 5)
     * @param flashDelay number of seconds to wait after the page has loaded if Flash elements are present. Use flash_delay&#x3D;0 to take screenshots faster. (optional, default to 10)
     * @param screenWidth width of the browser window. For desktop browsers only. (optional, default to 1024)
     * @param screenHeight height of the browser window. For desktop browsers only. (Note: full-page screenshots can have a height of up to 15,000px) (optional, default to 768)
     * @param priority assign priority to the screenshot (for private instances only) (optional)
     * @param referer use a custom referrer header - paid screenshots only (optional)
     * @param postData send a POST requests with post_data, useful for filling out forms - paid screenshots only (optional)
     * @param cookie set a cookie for the URL requested (see Custom POST Data, Referer and Cookie) Cookies should be separated by a ; - paid screenshots only (optional)
     * @param script URL of javascript file to execute after the page load event (optional)
     * @param details level of information available with screenshot/info (optional, default to 2)
     * @param html saves the HTML of the rendered page which can be retrieved by the API call screenshot/html. This feature costs *1 credit* per screenshot. (optional, default to 0)
     * @param maxWait maximum number of seconds to wait before triggering the PageLoad event. Note that delay will still be used. (default: 0 &#x3D; disabled) (optional, default to 0)
     * @param headers any custom HTTP headers. (Not supported with Internet Explorer) (optional)
     * @param hosting hosting option - s3 or browshot (optional)
     * @param hostingHeight maximum height of the thumbnail to host (optional)
     * @param hostingWidth maximum height of the thumbnail to host (optional)
     * @param hostingScale scale of the thumbnail to host (optional, default to 1)
     * @param hostingBucket S3 bucket to upload the screenshot or thumbnail (required for S3) (optional)
     * @param hostingFile file name to use (for S3 only) (optional)
     * @param hostingHeaders list of headers to add to the S3 object (for S3 only) (optional)
     * @return ApiResponse&lt;ScreenshotList&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<ScreenshotList> screenshotMultipleGetWithHttpInfo(String url, Integer instanceId, String size, Integer cache, Integer delay, Integer flashDelay, Integer screenWidth, Integer screenHeight, Integer priority, String referer, String postData, String cookie, String script, Integer details, Integer html, Integer maxWait, String headers, String hosting, Integer hostingHeight, Integer hostingWidth, Float hostingScale, String hostingBucket, String hostingFile, String hostingHeaders) throws ApiException {
        com.squareup.okhttp.Call call = screenshotMultipleGetValidateBeforeCall(url, instanceId, size, cache, delay, flashDelay, screenWidth, screenHeight, priority, referer, postData, cookie, script, details, html, maxWait, headers, hosting, hostingHeight, hostingWidth, hostingScale, hostingBucket, hostingFile, hostingHeaders, null, null);
        Type localVarReturnType = new TypeToken<ScreenshotList>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Request multiple screenshots (asynchronously)
     * Request multiple screenshots in one API call. The API call accepts all the parameters supported by screenshot/create. You can specify up to 10 URLs and 10 instances for a total of 100 screenshots in one API call. 
     * @param url URL of the page to get a screenshot for. You can specify multiple url parameters (up to 10). (required)
     * @param instanceId instance ID to use. You can specify multiple instance_id parameters (up to 10). (required)
     * @param size screenshot size - \&quot;screen\&quot; (default) or \&quot;page\&quot; (optional, default to screen)
     * @param cache use a previous screenshot (same URL, same instance) if it was done within &lt;cache_value&gt; seconds. The default value is 24hours. Specify cache&#x3D;0 if you want a new screenshot. (optional, default to 86400)
     * @param delay number of seconds to wait after the page has loaded. This is used to let JavaScript run longer before taking the screenshot. Use delay&#x3D;0 to take screenshots faster. (optional, default to 5)
     * @param flashDelay number of seconds to wait after the page has loaded if Flash elements are present. Use flash_delay&#x3D;0 to take screenshots faster. (optional, default to 10)
     * @param screenWidth width of the browser window. For desktop browsers only. (optional, default to 1024)
     * @param screenHeight height of the browser window. For desktop browsers only. (Note: full-page screenshots can have a height of up to 15,000px) (optional, default to 768)
     * @param priority assign priority to the screenshot (for private instances only) (optional)
     * @param referer use a custom referrer header - paid screenshots only (optional)
     * @param postData send a POST requests with post_data, useful for filling out forms - paid screenshots only (optional)
     * @param cookie set a cookie for the URL requested (see Custom POST Data, Referer and Cookie) Cookies should be separated by a ; - paid screenshots only (optional)
     * @param script URL of javascript file to execute after the page load event (optional)
     * @param details level of information available with screenshot/info (optional, default to 2)
     * @param html saves the HTML of the rendered page which can be retrieved by the API call screenshot/html. This feature costs *1 credit* per screenshot. (optional, default to 0)
     * @param maxWait maximum number of seconds to wait before triggering the PageLoad event. Note that delay will still be used. (default: 0 &#x3D; disabled) (optional, default to 0)
     * @param headers any custom HTTP headers. (Not supported with Internet Explorer) (optional)
     * @param hosting hosting option - s3 or browshot (optional)
     * @param hostingHeight maximum height of the thumbnail to host (optional)
     * @param hostingWidth maximum height of the thumbnail to host (optional)
     * @param hostingScale scale of the thumbnail to host (optional, default to 1)
     * @param hostingBucket S3 bucket to upload the screenshot or thumbnail (required for S3) (optional)
     * @param hostingFile file name to use (for S3 only) (optional)
     * @param hostingHeaders list of headers to add to the S3 object (for S3 only) (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call screenshotMultipleGetAsync(String url, Integer instanceId, String size, Integer cache, Integer delay, Integer flashDelay, Integer screenWidth, Integer screenHeight, Integer priority, String referer, String postData, String cookie, String script, Integer details, Integer html, Integer maxWait, String headers, String hosting, Integer hostingHeight, Integer hostingWidth, Float hostingScale, String hostingBucket, String hostingFile, String hostingHeaders, final ApiCallback<ScreenshotList> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = screenshotMultipleGetValidateBeforeCall(url, instanceId, size, cache, delay, flashDelay, screenWidth, screenHeight, priority, referer, postData, cookie, script, details, html, maxWait, headers, hosting, hostingHeight, hostingWidth, hostingScale, hostingBucket, hostingFile, hostingHeaders, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<ScreenshotList>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for screenshotSearchGet */
    private com.squareup.okhttp.Call screenshotSearchGetCall(String url, Integer limit, String status, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/screenshot/search".replaceAll("\\{format\\}","json");

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (url != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "url", url));
        if (limit != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "limit", limit));
        if (status != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "status", status));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "apiKeyQuery" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call screenshotSearchGetValidateBeforeCall(String url, Integer limit, String status, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'url' is set
        if (url == null) {
            throw new ApiException("Missing the required parameter 'url' when calling screenshotSearchGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = screenshotSearchGetCall(url, limit, status, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Search for screenshots of a specific URL.
     * Search for screenshots of a specific URL.
     * @param url look for a string matching the URL requested (required)
     * @param limit maximum number of screenshots&#39; information to return (optional, default to 50)
     * @param status get list of screenshot in a given status (error, finished, in_process) (optional)
     * @return List&lt;ScreenshotList&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<ScreenshotList> screenshotSearchGet(String url, Integer limit, String status) throws ApiException {
        ApiResponse<List<ScreenshotList>> resp = screenshotSearchGetWithHttpInfo(url, limit, status);
        return resp.getData();
    }

    /**
     * Search for screenshots of a specific URL.
     * Search for screenshots of a specific URL.
     * @param url look for a string matching the URL requested (required)
     * @param limit maximum number of screenshots&#39; information to return (optional, default to 50)
     * @param status get list of screenshot in a given status (error, finished, in_process) (optional)
     * @return ApiResponse&lt;List&lt;ScreenshotList&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<ScreenshotList>> screenshotSearchGetWithHttpInfo(String url, Integer limit, String status) throws ApiException {
        com.squareup.okhttp.Call call = screenshotSearchGetValidateBeforeCall(url, limit, status, null, null);
        Type localVarReturnType = new TypeToken<List<ScreenshotList>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Search for screenshots of a specific URL. (asynchronously)
     * Search for screenshots of a specific URL.
     * @param url look for a string matching the URL requested (required)
     * @param limit maximum number of screenshots&#39; information to return (optional, default to 50)
     * @param status get list of screenshot in a given status (error, finished, in_process) (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call screenshotSearchGetAsync(String url, Integer limit, String status, final ApiCallback<List<ScreenshotList>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = screenshotSearchGetValidateBeforeCall(url, limit, status, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<ScreenshotList>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for screenshotShareGet */
    private com.squareup.okhttp.Call screenshotShareGetCall(Integer id, String note, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/screenshot/share".replaceAll("\\{format\\}","json");

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (id != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "id", id));
        if (note != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "note", note));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "apiKeyQuery" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call screenshotShareGetValidateBeforeCall(Integer id, String note, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling screenshotShareGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = screenshotShareGetCall(id, note, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Share a screenshot
     * You can make your screenshots public, add notes, and share it with your friends and colleagues. Only screenshots which are successfully completed can be shared.n the thumbnail. You can take a 1024x768 screenshot, crop it to 768x768, and get it scaled down to 300x300. 
     * @param id screenshot ID (required)
     * @param note note to add on the sharing page (optional)
     * @return List&lt;ScreenshotHost&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<ScreenshotHost> screenshotShareGet(Integer id, String note) throws ApiException {
        ApiResponse<List<ScreenshotHost>> resp = screenshotShareGetWithHttpInfo(id, note);
        return resp.getData();
    }

    /**
     * Share a screenshot
     * You can make your screenshots public, add notes, and share it with your friends and colleagues. Only screenshots which are successfully completed can be shared.n the thumbnail. You can take a 1024x768 screenshot, crop it to 768x768, and get it scaled down to 300x300. 
     * @param id screenshot ID (required)
     * @param note note to add on the sharing page (optional)
     * @return ApiResponse&lt;List&lt;ScreenshotHost&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<ScreenshotHost>> screenshotShareGetWithHttpInfo(Integer id, String note) throws ApiException {
        com.squareup.okhttp.Call call = screenshotShareGetValidateBeforeCall(id, note, null, null);
        Type localVarReturnType = new TypeToken<List<ScreenshotHost>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Share a screenshot (asynchronously)
     * You can make your screenshots public, add notes, and share it with your friends and colleagues. Only screenshots which are successfully completed can be shared.n the thumbnail. You can take a 1024x768 screenshot, crop it to 768x768, and get it scaled down to 300x300. 
     * @param id screenshot ID (required)
     * @param note note to add on the sharing page (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call screenshotShareGetAsync(Integer id, String note, final ApiCallback<List<ScreenshotHost>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = screenshotShareGetValidateBeforeCall(id, note, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<ScreenshotHost>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /* Build call for screenshotThumbnailGet */
    private com.squareup.okhttp.Call screenshotThumbnailGetCall(Integer id, Integer width, Integer height, Double scale, Integer zoom, String ratio, Integer left, Integer right, Integer top, Integer bottom, String format, Integer shot, Integer quality, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/screenshot/thumbnail".replaceAll("\\{format\\}","json");

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        if (id != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "id", id));
        if (width != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "width", width));
        if (height != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "height", height));
        if (scale != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "scale", scale));
        if (zoom != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "zoom", zoom));
        if (ratio != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "ratio", ratio));
        if (left != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "left", left));
        if (right != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "right", right));
        if (top != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "top", top));
        if (bottom != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "bottom", bottom));
        if (format != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "format", format));
        if (shot != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "shot", shot));
        if (quality != null)
        localVarQueryParams.addAll(apiClient.parameterToPairs("", "quality", quality));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "image/png", "image/jpeg"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "apiKeyQuery" };
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call screenshotThumbnailGetValidateBeforeCall(Integer id, Integer width, Integer height, Double scale, Integer zoom, String ratio, Integer left, Integer right, Integer top, Integer bottom, String format, Integer shot, Integer quality, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling screenshotThumbnailGet(Async)");
        }
        
        
        com.squareup.okhttp.Call call = screenshotThumbnailGetCall(id, width, height, scale, zoom, ratio, left, right, top, bottom, format, shot, quality, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Retrieve a thumbnail image
     * Unlike the other API calls, this API sends back the thumbnail as a PNG file, not JSON. The HTTP response code indicates whether the screenshot was successful (200), or incomplete (404) or failed (404). If the screenshot failed or is not finished, a default image \&quot;Not found\&quot; is sent.  You can crop your screenshots. The crop is done first, then the thumbnail. You can take a 1024x768 screenshot, crop it to 768x768, and get it scaled down to 300x300. 
     * @param id screenshot ID (required)
     * @param width width of the thumbnail (optional)
     * @param height height of the thumbnail (optional)
     * @param scale scale of the thumbnail (optional, default to 1)
     * @param zoom zoom 1 to 100 percent (optional, default to 100)
     * @param ratio Use fit to keep the original page ration, and fill to get a thumbnail for the exact width and height.  specified. If you provide both width and height, you need to specify the ratio: fit to keep the original width/height ratio (the thumbnail might be smaller than the specified width and height), or fill to crop the image if necessary. (optional, default to fit)
     * @param left left edge of the area to be cropped (optional, default to 0)
     * @param right right edge of the area to be cropped (optional, default to 0)
     * @param top top edge of the area to be cropped (optional, default to 0)
     * @param bottom bottom edge of the area to be cropped (optional)
     * @param format image as PNG or JPEG (optional, default to png)
     * @param shot get the second or third screenshot if multiple screenshots were requested (optional, default to 1)
     * @param quality JPEG quality factor (for JPEG thumbnails only) (optional, default to 100)
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public void screenshotThumbnailGet(Integer id, Integer width, Integer height, Double scale, Integer zoom, String ratio, Integer left, Integer right, Integer top, Integer bottom, String format, Integer shot, Integer quality) throws ApiException {
        screenshotThumbnailGetWithHttpInfo(id, width, height, scale, zoom, ratio, left, right, top, bottom, format, shot, quality);
    }

    /**
     * Retrieve a thumbnail image
     * Unlike the other API calls, this API sends back the thumbnail as a PNG file, not JSON. The HTTP response code indicates whether the screenshot was successful (200), or incomplete (404) or failed (404). If the screenshot failed or is not finished, a default image \&quot;Not found\&quot; is sent.  You can crop your screenshots. The crop is done first, then the thumbnail. You can take a 1024x768 screenshot, crop it to 768x768, and get it scaled down to 300x300. 
     * @param id screenshot ID (required)
     * @param width width of the thumbnail (optional)
     * @param height height of the thumbnail (optional)
     * @param scale scale of the thumbnail (optional, default to 1)
     * @param zoom zoom 1 to 100 percent (optional, default to 100)
     * @param ratio Use fit to keep the original page ration, and fill to get a thumbnail for the exact width and height.  specified. If you provide both width and height, you need to specify the ratio: fit to keep the original width/height ratio (the thumbnail might be smaller than the specified width and height), or fill to crop the image if necessary. (optional, default to fit)
     * @param left left edge of the area to be cropped (optional, default to 0)
     * @param right right edge of the area to be cropped (optional, default to 0)
     * @param top top edge of the area to be cropped (optional, default to 0)
     * @param bottom bottom edge of the area to be cropped (optional)
     * @param format image as PNG or JPEG (optional, default to png)
     * @param shot get the second or third screenshot if multiple screenshots were requested (optional, default to 1)
     * @param quality JPEG quality factor (for JPEG thumbnails only) (optional, default to 100)
     * @return ApiResponse&lt;Void&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<Void> screenshotThumbnailGetWithHttpInfo(Integer id, Integer width, Integer height, Double scale, Integer zoom, String ratio, Integer left, Integer right, Integer top, Integer bottom, String format, Integer shot, Integer quality) throws ApiException {
        com.squareup.okhttp.Call call = screenshotThumbnailGetValidateBeforeCall(id, width, height, scale, zoom, ratio, left, right, top, bottom, format, shot, quality, null, null);
        return apiClient.execute(call);
    }

    /**
     * Retrieve a thumbnail image (asynchronously)
     * Unlike the other API calls, this API sends back the thumbnail as a PNG file, not JSON. The HTTP response code indicates whether the screenshot was successful (200), or incomplete (404) or failed (404). If the screenshot failed or is not finished, a default image \&quot;Not found\&quot; is sent.  You can crop your screenshots. The crop is done first, then the thumbnail. You can take a 1024x768 screenshot, crop it to 768x768, and get it scaled down to 300x300. 
     * @param id screenshot ID (required)
     * @param width width of the thumbnail (optional)
     * @param height height of the thumbnail (optional)
     * @param scale scale of the thumbnail (optional, default to 1)
     * @param zoom zoom 1 to 100 percent (optional, default to 100)
     * @param ratio Use fit to keep the original page ration, and fill to get a thumbnail for the exact width and height.  specified. If you provide both width and height, you need to specify the ratio: fit to keep the original width/height ratio (the thumbnail might be smaller than the specified width and height), or fill to crop the image if necessary. (optional, default to fit)
     * @param left left edge of the area to be cropped (optional, default to 0)
     * @param right right edge of the area to be cropped (optional, default to 0)
     * @param top top edge of the area to be cropped (optional, default to 0)
     * @param bottom bottom edge of the area to be cropped (optional)
     * @param format image as PNG or JPEG (optional, default to png)
     * @param shot get the second or third screenshot if multiple screenshots were requested (optional, default to 1)
     * @param quality JPEG quality factor (for JPEG thumbnails only) (optional, default to 100)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call screenshotThumbnailGetAsync(Integer id, Integer width, Integer height, Double scale, Integer zoom, String ratio, Integer left, Integer right, Integer top, Integer bottom, String format, Integer shot, Integer quality, final ApiCallback<Void> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = screenshotThumbnailGetValidateBeforeCall(id, width, height, scale, zoom, ratio, left, right, top, bottom, format, shot, quality, progressListener, progressRequestListener);
        apiClient.executeAsync(call, callback);
        return call;
    }
}
